---
name: Feature request
about: How to raise feature requests
---


Note: New issues raised, where it is clear the submitter has not read the issue template, are likely to be closed with "please read the issue template". Please don't take offense at this. It is simply a time management decision. If someone raises an issue, and can't be bothered to spend the time to read the issue template, then the project maintainers should not be expected to spend the time to read the submitted issue. Often too much time is spent going back and forth in issue comments asking for information that is outlined in the issue template.

If you are certain the feature will be accepted, it is better to raise a [Pull Request (PR)](https://help.github.com/articles/about-pull-requests/).

If you are uncertain if the feature will be accepted, outline the proposal below to confirm it is viable, prior to raising a PR that implements the feature.

Note that even if the feature is a good idea and viable, it may not be accepted since the ongoing effort in maintaining the feature may outweigh the benefit it delivers.


#### Is the feature request related to a problem

A clear and concise description of what the problem is.


#### Describe the solution

A clear and concise proposal of how you intend to implement the feature.


#### Describe alternatives considered

A clear and concise description of any alternative solutions or features you've considered.


#### Additional context

Add any other context about the feature request here.
